import Flutter
import UIKit

public class SwiftFgxPlugin: NSObject, FlutterPlugin, UIApplicationDelegate {
    var url: URL?
    var channel: FlutterMethodChannel?

    public static func register(with registrar: FlutterPluginRegistrar) {
        let instance = SwiftFgxPlugin()
        instance.channel = FlutterMethodChannel(name: "fgx_plugin", binaryMessenger: registrar.messenger())
        registrar.addMethodCallDelegate(instance, channel: instance.channel!)
        registrar.addApplicationDelegate(instance)
    }

    public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
        let deviceInfo = FGXDeviceInfo()
        switch call.method {
        case "get_url":
            result(url?.absoluteString)
            url = nil
        case "deviceId":
            result(deviceInfo.deviceId)
        case "idfv":
            result(deviceInfo.idfv)
        case "idfa":
            result(deviceInfo.idfa)
        case "deviceIP":
            result(deviceInfo.deviceIP)
        case "platformVersion":
            result(deviceInfo.platformVersion)
        case "location":
            result(deviceInfo.location)
        case "language":
            result(deviceInfo.language)
        case "allResources":
            result(deviceInfo.allResources)
        default:
            result(FlutterMethodNotImplemented)
        }
    }

    public func application(_ app: UIApplication, open url: URL, options: [UIApplication.OpenURLOptionsKey: Any] = [:]) -> Bool {
        self.url = url
        channel?.invokeMethod("open_url", arguments: url.absoluteString, result: { [weak self] result in
            if (result != nil) == true {
                self?.url = url
            }
        })
        return true
    }
}
