
import 'dart:async';

import 'package:flutter/services.dart';

class FgxPlugin {
  static const MethodChannel _channel = MethodChannel('fgx_plugin');

  static Future<String?> get platformVersion async {
    final String? version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static Future<List<String>?> get allResources async {
    final List<dynamic>? allResources = await _channel.invokeMethod('allResources');
    if (allResources == null){
      return null;
    }
    List<String> resources = [];
    for (var item in allResources) {
      resources.add(item as String);
    }
    return resources;
  }
}